<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>


<xsl:template name ="template_signalback" >
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>


// proxy
public interface IProxy_method_<xsl:value-of select="name"/>
{
    void on_signalback( <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _sig_data_,</xsl:if> double _elapsed);
    void on_cancel( Int32 _err);
}
public unsafe class Proxy_method_<xsl:value-of select="name"/>
{
    static Nerv36.Proxy_signalback.on_signalback_ft on_signalback_ = new Nerv36.Proxy_signalback.on_signalback_ft(on_signalback);
    static Nerv36.Proxy_signalback.on_cancel_ft on_cancel_ = new Nerv36.Proxy_signalback.on_cancel_ft(on_cancel);
    static ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt;();

    public static void on_signalback(IntPtr _signalback_, IntPtr _sig_data_, UInt32 _sig_size, double _elapsed)
    {<xsl:if test="out_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* sig_data_ = (Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>*)_sig_data_;
        </xsl:if>
        dict[_signalback_].isignalback.on_signalback(<xsl:if test="out_data!='(null)'"> ref *sig_data_,</xsl:if> _elapsed);
    }
    public static void on_cancel(IntPtr _signalback_, Int32 _err)
    {
        dict[_signalback_].isignalback.on_cancel(_err);
    }

    public IntPtr signalback_;
    public IProxy_method_<xsl:value-of select="name"/> isignalback;

    public Proxy_method_<xsl:value-of select="name"/>(ref Nerv36.Proxy _object_, IProxy_method_<xsl:value-of select="name"/> _isignalback)
    {
        signalback_ = Nerv36.Proxy_signalback.alloc(<xsl:value-of select="code"/>, _object_.object_, on_signalback_, on_cancel_);
        dict[signalback_] = this;
        isignalback = _isignalback;
    }
    ~Proxy_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Proxy_signalback.free(signalback_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Proxy_signalback.free(signalback_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Proxy_method_<xsl:value-of select="name"/> signalback;
        dict.TryRemove(signalback_, out signalback);
    }
}



// stub
public interface IStub_method_<xsl:value-of select="name"/>
{
    void on_return(UInt32 _msg_num, Address _proxy_addr, Int32 _err, Double _elapsed);
}
public unsafe class Stub_method_<xsl:value-of select="name"/>
{
    static Nerv36.Stub_signalback.on_return_ft on_return_ = new Nerv36.Stub_signalback.on_return_ft(on_return);

    static ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt;();

    public static void on_return(IntPtr _signalback_, UInt32 _msg_num, Address _proxy_addr, Int32 _err, Double _elapsed)
    {
        dict[_signalback_].isignalback.on_return(_msg_num, _proxy_addr, _err, _elapsed);
    }

    public IntPtr signalback_;
    public IStub_method_<xsl:value-of select="name"/> isignalback;

    public Stub_method_<xsl:value-of select="name"/>(ref Nerv36.Stub _object_, IStub_method_<xsl:value-of select="name"/> _isignalback )
    {
        signalback_ = Nerv36.Stub_signalback.alloc(<xsl:value-of select="code"/>, _object_.object_, on_return_);
        dict[signalback_] = this;
        isignalback = _isignalback;
    }
    ~Stub_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Stub_signalback.free(signalback_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Stub_signalback.free(signalback_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Stub_method_<xsl:value-of select="name"/> signalback;
        dict.TryRemove(signalback_, out signalback);
    }

    public Int32 delegate_signalback(ref UInt32 _msg_num_, Address _proxy_addr,<xsl:if test="out_data!='(null)'"> ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _sig_data_,</xsl:if> Double _limit)
    {
        <xsl:if test="out_data!='(null)'">
        Int32 err;
        UInt32 sig_size = (UInt32)_sig_data_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* sig_data_ = &amp;_sig_data_)
        {
            err = Nerv36.Stub_signalback.delegate_signalback( signalback_, ref _msg_num_, _proxy_addr, (IntPtr)sig_data_, sig_size, _limit);
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        Int32 err = Nerv36.Stub_signalback.delegate_signalback( signalback_, ref _msg_num_, _proxy_addr, IntPtr.Zero, 0, _limit);
        </xsl:if>
        return err;
    }


    public IntPtr async_signalback( Address _proxy_addr, <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _sig_data_,</xsl:if> Double _limit)
    {
        <xsl:if test="out_data!='(null)'">
        UInt32 sig_size = (UInt32)_sig_data_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* sig_data_ = &amp;_sig_data_)
        {
            IntPtr promise_ = Nerv36.Stub_signalback.async_signalback( signalback_, _proxy_addr, (IntPtr)sig_data_, sig_size, _limit);
            return promise_;
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        IntPtr promise_ = Nerv36.Stub_signalback.async_signalback( signalback_, _proxy_addr, IntPtr.Zero, 0, _limit);
        return promise_;
        </xsl:if>
    }


    public Int32 await_return(IntPtr _promise_, ref Double _elapsed_ )
    {
        Int32 err = Nerv36.Stub_signalback.await_return(signalback_, _promise_, ref _elapsed_);
        return err;
    }

    public Int32 signalback( Address _proxy_addr, <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _sig_data_,</xsl:if> Double _limit , ref Double _elapsed_ )
    {
        <xsl:if test="out_data!='(null)'">
        UInt32 sig_size = (UInt32)_sig_data_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* sig_data_ = &amp;_sig_data_)
        {
            Int32 err = Nerv36.Stub_signalback.signalback( signalback_, _proxy_addr, (IntPtr)sig_data_, sig_size, _limit, ref _elapsed_);
            return err;
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        Int32 err = Nerv36.Stub_signalback.signalback( signalback_, _proxy_addr, IntPtr.Zero, 0, _limit, ref _elapsed_);
        return err;
        </xsl:if>
    }

    public void cancel( Address _proxy_addr, Int32 _err)
    {
        Nerv36.Stub_signalback.cancel(signalback_, _proxy_addr, _err);
    }
}


</xsl:template>




</xsl:stylesheet>
