﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv36
{
    public class Proxy_signal
    {
        public delegate void on_return_ft(IntPtr _signal_, UInt32 _msg_num, Int32 _err, Double _elapsed);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object_, on_return_ft on_return_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_free")]
        public static extern void free(IntPtr _signal_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_delegate_signal")]
        public static extern Int32 delegate_signal(IntPtr _signal_, ref UInt32 _msg_num_, IntPtr _sig_data_, UInt32 _sig_size, Double _limit);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_async_signal")]
        public static extern IntPtr async_signal(IntPtr _signal_, IntPtr _sig_data_, UInt32 _sig_size, Double _limit);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_await_return")]
        public static extern Int32 await_return(IntPtr _signal_, IntPtr _promise_, ref Double _elapsed_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_signal")]
        public static extern Int32 signal(IntPtr _signal_, IntPtr _sig_data_, UInt32 _sig_size, Double _limit, ref Double _elapsed_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_cancel")]
        public static extern void cancel(IntPtr _signal_, Int32 _err);
    }
}
