#pragma once

#include <string>
#include <string.h>

inline const char* fgets(std::string* _ref_, FILE * _fp_)
{
    char buf[128];
    char* result;

    //*_ref_ = ""; // 초기화 하지 않음으로써 이전 문자열에 이어붙이는 효과를 나게 할수있다.
    // 만약 초기화가 필요하다면 함수호출전에 초기화 하고 호출하게 할수 있다.
    // 리턴값을 char* 로 하여 읽어 들인 위치만 취할수 있다.

    size_t s = _ref_->length();

    while(!feof(_fp_))
    {
        result = fgets(buf,sizeof(buf),_fp_);
        if(result==0)
        {
            break;
        }
        *_ref_ += buf;
        if( strlen(buf) < sizeof(buf)-1 )
        {
            break;
        }
    }
    return _ref_->c_str()+s;
}
