<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" encoding="utf-8" indent="yes"/>
<xsl:template name="chapter_3.2.5.2">

			<P PageBreak="true" InstId="" ParaShape="20" Style="3"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="8">
					<CHAR>인터페이스 목록(구 내부 인터페이스 관계)</CHAR>
				</TEXT>
			</P>

			<P ParaShape="30" Style="9">
				<TEXT CharShape="13">
					<TABLE BorderFill="4" CellSpacing="0" ColCount="4" PageBreak="Cell" RepeatHeader="true" RowCount="1">
						<xsl:attribute name="RowCount"><xsl:value-of select="count(/nerv_system_interface/system/nodes/node/processes/process/proxies/proxy)+1"/></xsl:attribute>
						<SHAPEOBJECT InstId="" Lock="false" NumberingType="None" ZOrder="6"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
							<SIZE Height="12270" HeightRelTo="Absolute" Protect="false" Width="46492" WidthRelTo="Absolute"/>
							<POSITION AffectLSpacing="false" AllowOverlap="false" FlowWithText="true" HoldAnchorAndSO="false" HorzAlign="Left" HorzOffset="0" HorzRelTo="Para" TreatAsChar="false" VertAlign="Top" VertOffset="0" VertRelTo="Para"/>
							<OUTSIDEMARGIN Bottom="283" Left="283" Right="283" Top="283"/>
						</SHAPEOBJECT>
						<INSIDEMARGIN Bottom="567" Left="850" Right="850" Top="567"/>
						<ROW>
							<CELL BorderFill="9" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="15500">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>Proxy</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>장비::소프트웨어</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="10000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>인터페이스</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="15500">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>Stub</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>장비::소프트웨어</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="3" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="5492">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>관련</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>항목</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/proxies/proxy">
	<xsl:variable name="proxy_name" select="name"/>
						<ROW>
							<CELL BorderFill="4" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="1" RowSpan="1" Width="15500">
								<xsl:attribute name="RowAddr"><xsl:value-of select="position()"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="../../../../name"/>::</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR>[<xsl:value-of select="../../name"/>]</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="1" RowSpan="1" Width="10000">
								<xsl:attribute name="RowAddr"><xsl:value-of select="position()"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="name"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="1" RowSpan="1" Width="15500">
								<xsl:attribute name="RowAddr"><xsl:value-of select="position()"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
	<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub[name=$proxy_name]">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="../../../../name"/>::</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR>[<xsl:value-of select="../../name"/>]</CHAR>
										</TEXT>
									</P>
	</xsl:for-each>
									<P/>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="3" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="1" RowSpan="1" Width="5492">
								<xsl:attribute name="RowAddr"><xsl:value-of select="position()"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR>3.1.2.<xsl:value-of select="position()+2"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
</xsl:for-each>
					</TABLE>
					<CHAR/>
				</TEXT>
			</P>



</xsl:template>
</xsl:stylesheet>
