#pragma once

#include "Proxy.hh"

namespace Nerv36 {

class NERV_SDK_DLL Proxy_datagram : virtual public Proxy {
    friend class _Proxy_datagram;

public:
    Proxy_datagram(Msg_code _code);
    Proxy_datagram(Msg_code _code, const Proxy& _proxy_object_);
    virtual ~Proxy_datagram(void);

protected:
    virtual void on_datagram(Address        _stub_addr,
                             const void* _buf_,
                             Pksize      _size,
                             double      _elapsed);

private:
    _Proxy_datagram* _mp;
};

} // namespace Nerv36
