﻿#include <stdio.h> 
#include <WinSock2.h>
#include <thread>

void receiver( SOCKET _server)
{
    printf("start receiver\n");
    // infinite loop for chat 
    for (;;) {
        char byte;
        int rlen = recv(_server, (char*)&byte, 1, MSG_WAITALL);
        if (rlen <= 0) break;
        printf("%c : %02X\n", byte, byte);
    }
    printf("closesocket\n");
    closesocket(_server);
}

// Driver function 
int main()
{
    int iResult;
    WSADATA wsaData;
    // Initialize Winsock
    iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
    if (iResult != 0) {
        printf("WSAStartup failed: %d\n", iResult);
        return 1;
    }

    // socket create and verification 
    SOCKET listener = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (listener == -1) {
        printf("socket creation failed...\n");
        exit(0);
    }
    else
        printf("Socket successfully created..\n");
    

    // assign IP, PORT 
    sockaddr_in servaddr;
    memset(&servaddr, 0, sizeof(servaddr));    
    servaddr.sin_family = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port = htons(5959);

    // Binding newly created socket to given IP and verification 
    if ((bind(listener, (sockaddr*)&servaddr, sizeof(servaddr))) != 0) {
        printf("socket bind failed...\n");
        exit(0);
    }
    else
        printf("Socket successfully binded..\n");

    // Now server is ready to listen and verification 
    if ((listen(listener, 5)) != 0) {
        printf("Listen failed...\n");
        exit(0);
    }
    else
        printf("Server listening..\n");

    // Accept the data packet from client and verification 
    for (;;) {
        sockaddr_in cli;
        int len = sizeof(cli);
        SOCKET server = accept(listener, (sockaddr*)&cli, &len);
        if (server < 0) {
            printf("server acccept failed...\n");
            exit(0);
        }
        printf("server acccept the client...\n");
        std::thread* receiver_ = new std::thread(&receiver, server);
        receiver_->detach();
    }
    closesocket(listener);

    WSACleanup();
}
